/**
 *
 * Copyright (C) 2013, 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#include "stack.h"

stack *newStack(){
  stack* s = NULL;
  return s;
}

struct _stack* push(struct _stack* p, struct _simplex* d){

  struct _stack* tmp = NULL;
  ALLOUER(tmp,1);
  d->stack = tmp;
  tmp->data = d;
  tmp->next = p;
  p = tmp;

  return p;
}

struct _stack* pop(struct _stack* p, struct _simplex** d){
  struct _stack* tmp = p;
  p->data->stack = NULL;
  *d = p->data;
  p = p->next;
  free(tmp);  
  return p;
}

int empty(struct _stack* p){
  return p == NULL ? 1 : 0;
}
