#ifndef IMAGE_H
#define IMAGE_H

#include "commun.h"
#define MAXLIGNE 9999 /* Longueur maximale d'une ligne de commentaire */

struct image
{
  int largeur ;
  int hauteur ;
  unsigned char **pixels ;
} ;



void lire_ligne(FILE *f, char *ligne) ;
struct image* allocation_image(int hauteur, int largeur) ;
void liberation_image(struct image*) ;
struct image* lecture_image(FILE *f) ;
void ecriture_image(FILE *f, const struct image *image) ;

#endif
